import { EventEmitter } from '../../Events/EventEmitter.js';
import { AsyncFlowNode } from '../../Nodes/AsyncFlowNode.js';
import { EventFlowNode } from '../../Nodes/EventFlowNode.js';
import { Link } from '../../Nodes/Link.js';
import { Graph } from '../Graph.js';
import { NodeEvaluationEvent } from './NodeEvaluationEvent.js';
export declare class GraphEvaluator {
    readonly graph: Graph;
    private readonly executionBlockQueue;
    readonly asyncFlowNodes: AsyncFlowNode[];
    readonly eventFlowNodes: EventFlowNode[];
    readonly onNodeEvaluation: EventEmitter<NodeEvaluationEvent>;
    constructor(graph: Graph);
    asyncCommit(outputFlowSocket: Link, syncEvaluationCompletedListener: (() => void) | undefined): void;
    executeAllSync(limitInSeconds?: number, limitInSteps?: number): number;
    executeAllAsync(limitInSeconds?: number, limitInSteps?: number): Promise<number>;
}
//# sourceMappingURL=GraphEvaluator.d.ts.map