import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class OnCustomEvent extends Node {
    constructor(graph, customEventId) {
        const customEvent = graph.customEvents[customEventId];
        const outputSockets = [
            new Socket('flow', 'flow'),
            ...customEvent.parameters.map((parameter) => new Socket(parameter.valueTypeName, parameter.name, parameter.value))
        ];
        super('Event', `event/customEvent/${customEvent.id}`, [], outputSockets, (context) => {
            customEvent.eventEmitter.addListener((parameters) => {
                Object.keys(parameters).forEach((parameterName) => context.writeOutput(parameterName, parameters[parameterName]));
                context.commit('flow');
            });
        });
        this.graph = graph;
        this.customEventId = customEventId;
        this.evaluateOnStartup = true;
        this.async = true;
        this.interruptibleAsync = true;
    }
}
//# sourceMappingURL=OnCustomEvent.js.map