import { AsyncNode } from '../../../Nodes/AsyncNode.js';
import { NodeDescription } from '../../../Nodes/Registry/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class Delay extends AsyncNode {
    constructor(description, graph) {
        super(description, graph, [new Socket('flow', 'flow'), new Socket('float', 'duration', 1)], [new Socket('flow', 'flow')]);
        this.timeoutPending = false;
    }
    triggered(engine, triggeringSocketName, finished) {
        if (this.timeoutPending) {
            return;
        }
        this.timeoutPending = true;
        setTimeout(() => {
            if (!this.timeoutPending)
                return;
            this.timeoutPending = false;
            engine.commitToNewFiber(this, 'flow');
            finished();
        }, this.readInput('duration') * 1000);
    }
    dispose() {
        this.timeoutPending = false;
    }
}
Delay.Description = new NodeDescription('flow/delay', 'Flow', 'Delay', (description, graph) => new Delay(description, graph));
//# sourceMappingURL=Delay.js.map