import { FlowNode } from '../../../Nodes/FlowNode.js';
import { NodeDescription } from '../../../Nodes/Registry/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class DoN extends FlowNode {
    constructor(description, graph) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            new Socket('integer', 'n', 1),
            new Socket('flow', 'reset')
        ], [new Socket('flow', 'flow'), new Socket('integer', 'count')]);
        this.count = 0;
    }
    triggered(fiber, triggeringSocketName) {
        if (triggeringSocketName === 'reset') {
            this.count = 0;
            return;
        }
        if (triggeringSocketName === 'flow') {
            if (this.count < Number(this.readInput('n'))) {
                this.writeOutput('count', this.count);
                this.count++;
                fiber.commit(this, 'flow');
            }
            return;
        }
        throw new Error('should not get here');
    }
}
DoN.Description = new NodeDescription('flow/doN', 'Flow', 'DoN', (description, graph) => new DoN(description, graph));
//# sourceMappingURL=DoN.js.map