import { FlowNode } from '../../../Nodes/FlowNode.js';
import { NodeDescription } from '../../../Nodes/Registry/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class DoOnce extends FlowNode {
    constructor(description, graph) {
        super(description, graph, [new Socket('flow', 'flow'), new Socket('flow', 'reset')], [new Socket('flow', 'flow')]);
        this.firedOnce = false;
    }
    triggered(fiber, triggeringSocketName) {
        if (triggeringSocketName === 'reset') {
            this.firedOnce = false;
            return;
        }
        if (triggeringSocketName === 'flow') {
            if (!this.firedOnce) {
                this.firedOnce = true;
                fiber.commit(this, 'flow');
            }
            return;
        }
        throw new Error('should not get here');
    }
}
DoOnce.Description = new NodeDescription('flow/doOnce', 'Flow', 'DoOnce', (description, graph) => new DoOnce(description, graph));
//# sourceMappingURL=DoOnce.js.map